#property indicator_separate_window
#property indicator_buffers 1
#property strict
//---- plot Line ---- See SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,clrGold);, I think it is identical
#property indicator_label1  "Found_Ratio_Line"   // Name that shows on 'hover over' of the line
#property indicator_type1   DRAW_LINE            // Draw a line for the indicator
#property indicator_color1  clrGold              // Make the line this color.  
#property indicator_style1  STYLE_SOLID 
#property indicator_width1  2

#property indicator_minimum -0.1  // Minimu range (top line on the window)
#property indicator_maximum 1.3   // Maximum range (top line on the window)
#property indicator_level1 0.0    // Draw a line in the indicator window here.
#property indicator_levelcolor Ivory  // Color of the lines drawin in the indicator window.
#property indicator_levelwidth 1  // How wide should the level line be drawn.
#include <stdlib.mqh>
//--- indicator buffers 
double         LineBuffer[];
//+------------------------------------------------------------------+
//| Indicies to Display Object Property Arrays                       |
//+------------------------------------------------------------------+
enum objectIndicies  // use these to access the display object properties.
{
   SHORTNAMEFIND = 0,
   WINDFIND,
   OBJFIND,
   DEBUGDISP,
   ObjIndiEnd
};
//+------------------------------------------------------------------+
//| display object control values and storage arrays                 |
//+------------------------------------------------------------------+ 
const ENUM_OBJECT ary_dispObjType[] = {       OBJ_LABEL,        OBJ_LABEL,      OBJ_LABEL,      OBJ_LABEL};
const string     ary_dispObjNames[] = { "ShortNameFind",     "WinObjFind",  "ObjFindDisp",    "DebugDisp"};
const int         ary_dispObjXPos[] = {              20,               20,             20,             20};
const int         ary_dispObjYPos[] = {              20,               40,             60,             80};
const color      ary_dispObjColor[] = {       clrYellow,        clrYellow,      clrYellow, clrYellowGreen};
string            ary_dispObjText[] = {              "",               "",             "",             ""};

ENUM_BASE_CORNER ControlAnchor = CORNER_RIGHT_UPPER;  //  Anchor the labels here.
//+------------------------------------------------------------------+
//| Variables to help capture what the indicaor is doing                |
//+------------------------------------------------------------------+ 
int WindowNum = -1;               // Store the outcome of WindowFind(short_name)
int DisplayNum = -1;              // Keep DisplayNum (the Window number used for display) separate from the WindowNum (the display window dectected)
uint countTimesWinNumChecked = 0; // Make the window display change / count the number of times the window number is detected
uint countTimesWinNumFound = 0;   // Make a ratio to display as an indicator - it will be bogus junk, just a line.
string short_name="IndiWindNum";  // See "IndicatorShortName(short_name);"
//+------------------------------------------------------------------+
//| Program Constants                                                |
//+------------------------------------------------------------------+
const int DISPALYWINDOWZERO = 0;
const int CURRENTCHART      = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() 
{
   EventSetTimer(1);                 // Start a Timer
   IndicatorShortName(short_name);   // give the indicator a name
   IndicatorDigits(Digits+1);        // What precision from the indicator calculation should be stored?
   //--- indicator buffers mapping
   IndicatorBuffers(1);              // How Many indicators, visible or not, will there be (1, indicator 0 in this case)
   SetIndexBuffer(0,LineBuffer);     // attach the array to the 1st indicator (line 1)
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,clrGold);  // How should this indicator be displayed?
   SetIndexShift(0,0);               // If there are multiple indicators, use shift to separate the lines if they are too close to see.
   SetIndexDrawBegin(0,0);           // How many bars should the indicator line be drawn for?
   //--- 
   return(INIT_SUCCEEDED); 
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialzation function                         |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();               // Clean up the timer when the indicator stops.
   DeleteObjects();                // Clean up the display when the indicator stops.
}
void DeleteObjects()
{
   for (int i = 0; i < ObjIndiEnd; i++)  // Delete the objects the indicator makes.
   {
      ObjectDelete(CURRENTCHART,ary_dispObjNames[i]);
   }
}
//+------------------------------------------------------------------+
//| Custom indicator timer function                                  |
//+------------------------------------------------------------------+
void OnTimer()
{
   DisplayNum = GetWindowNum();  // Get the window (sub window) the Indicator is running in
   SetLabelObjectText(SHORTNAMEFIND);
}
//+------------------------------------------------------------------+
//| Custom indicator Chart Event function                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,  const long &lparam, const double &dparam,  const string &sparam)
{
   if(id==CHARTEVENT_OBJECT_CLICK)
   {
      if (sparam==ary_dispObjNames[SHORTNAMEFIND])  // If this object is clicked, do this
      {
         SetLabelObjectText(WINDFIND);
         SetLabelObjectText(OBJFIND);
      }
      if (sparam==ary_dispObjNames[WINDFIND])       // If this object is clicked, do this
      {  //  Do Nothing?  Have it delete itself to get it off the display?
         ObjectDelete(CURRENTCHART,ary_dispObjNames[WINDFIND]);
      }
      if (sparam==ary_dispObjNames[OBJFIND])        // If this object is clicked, do this
      {  //  Do Nothing?  Have it delete itself to get it off the display?
         ObjectDelete(CURRENTCHART,ary_dispObjNames[OBJFIND]);
      }
   }
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, 
                const int prev_calculated, 
                const datetime& time[], 
                const double& open[], 
                const double& high[], 
                const double& low[], 
                const double& close[], 
                const long& tick_volume[], 
                const long& volume[], 
                const int& spread[]) 
{
   static uint callCount = 0;
   callCount ++;
   if ( callCount < 3 )
   {
      Print("Call Count: ",IntegerToString(callCount),", rates_total: ",IntegerToString(rates_total),", prev_calculated: ",IntegerToString(prev_calculated) );
   }
   DisplayNum = GetWindowNum();  // Get the window (sub window) the Indicator is running in
   if ( rates_total > 0 )        // I don't think this test is necessary.  See the output of the above Print.
   {
      int iNewBars = (rates_total - prev_calculated);  // find out the number of uncalculated bars
      iNewBars --;  // One less because the first is zero, will produce an out of range error in the for statement
      for(int i=iNewBars; i>=0; i--)      // The oldest bar has the largest index, work your way to 0, the newest Bar.
      {
         if ( 0< countTimesWinNumChecked )  // prevent divide by zero, but give each LineBuffer array entry a value.
         {
            LineBuffer[i] = ((double)countTimesWinNumFound) / ((double)countTimesWinNumChecked);
         } else
         {
            LineBuffer[i] = 0.5;
         }
         ary_dispObjText[DEBUGDISP] = "LineBuffer["+IntegerToString(i)+"] = "+DoubleToStr(LineBuffer[i],_Digits)+", Called: "+IntegerToString(countTimesWinNumChecked)+", Looked Up: "+IntegerToString(countTimesWinNumFound);
         MakeALabel(DEBUGDISP);
      }
   }
   return(rates_total); 
}
//========= Get the Window (Sib-Window) number the Indicator is running in ================
int GetWindowNum()
{
   static int lastDisplayNum = 0;
   int displayNum;
   countTimesWinNumChecked ++;   // count the number of times called, make availale for display (Global)
   if ( (WindowNum < 0) || (WindowFind(short_name) != lastDisplayNum) ) //  invalid window num, or WindowNum has changed
   {
      displayNum = WindowFind( short_name );     // If this object is clicked, do this
      if (displayNum < 0 ) // Still didn't get it.  // Did WindowFind get a valid window number?
      {
         displayNum = 0;   // Just use 0 as a vaild window number if WindowFind failed.
      } else
      {
         countTimesWinNumFound ++;  // Cound the number of times WindowFind was called and worked.
         WindowNum = displayNum;    // Assign the good found number to WindowNum
      }
   } else
   {
      displayNum = WindowNum;  // If WindowNm is valid make sure display num is the same.
   }
   if ( displayNum != lastDisplayNum )  // If the Window number has changed (a different indicator was deleted)
   {
      DeleteObjects();     // remove the objects from the old window so they will be re-created in the new window
      lastDisplayNum = displayNum;  // Keep it so that we can detect when it changes
   }
   return(displayNum);     // In this indicator, this return is assigned to WindowNum
}
//========= Create and display text for the label objects ================
void SetLabelObjectText(const int ObjectID)
{
   switch(ObjectID)          //  Switch on the display objects:  Include not-lable objects to creater debug msg if erroneously called.
   {
      case SHORTNAMEFIND:
         ary_dispObjText[ObjectID] = StringConcatenate("Detect Called ", IntegerToString(countTimesWinNumChecked)," times. WindowFind(",short_name,") = ",WindowFind(short_name));
         MakeALabel(ObjectID);
         break;
      case WINDFIND:
         ary_dispObjText[ObjectID] = StringConcatenate("Detect Called ", IntegerToString(countTimesWinNumChecked)," times. WindowFind(",ary_dispObjNames[WINDFIND],") = ",WindowFind(ary_dispObjNames[WINDFIND]));
         MakeALabel(ObjectID);
         break;
      case OBJFIND:
         ary_dispObjText[ObjectID] = StringConcatenate("Detect Called ", IntegerToString(countTimesWinNumChecked)," times. ObjectFind(",ary_dispObjNames[WINDFIND],") = ",ObjectFind(CURRENTCHART,ary_dispObjNames[WINDFIND]));
         MakeALabel(ObjectID);
         break;
      case DEBUGDISP:
         MakeALabel(ObjectID);
         break;
      default:
         break;
   }
}
//+------------------------------------------------------------------+
//| Display Label objects                                            |
//+------------------------------------------------------------------+
void MakeALabel(int displayOjectIndex)   // Display Text
{
   int windowIndex=ObjectFind(ary_dispObjNames[displayOjectIndex]); // Find which window the object is in (does it exist?)
   if(windowIndex<0) // No window found with the object in it - Create the object
   {
      ObjectCreate(CURRENTCHART,ary_dispObjNames[displayOjectIndex], OBJ_LABEL, DisplayNum, 0, 0);    // Create on window 0
      ObjectSetInteger(CURRENTCHART,ary_dispObjNames[displayOjectIndex],OBJPROP_ANCHOR,CORNER_LEFT_UPPER);   //  Attach the text to the corner of the lable.
      ObjectSetInteger(CURRENTCHART,ary_dispObjNames[displayOjectIndex],OBJPROP_HIDDEN,true);                 // Hidden, must press 'all' to see in object list
      ObjectSet(ary_dispObjNames[displayOjectIndex], OBJPROP_CORNER, ControlAnchor);                          // attach the lable to the corner of the chart
   }
   ObjectSet(ary_dispObjNames[displayOjectIndex], OBJPROP_XDISTANCE, ary_dispObjXPos[displayOjectIndex]);             // justify at xPos from the right
   ObjectSet(ary_dispObjNames[displayOjectIndex], OBJPROP_YDISTANCE, ary_dispObjYPos[displayOjectIndex]);             // place at yPos from the top 
   ObjectSetText(ary_dispObjNames[displayOjectIndex],ary_dispObjText[displayOjectIndex],10,"Tahoma",ary_dispObjColor[displayOjectIndex]);  // display the text
}